/*******************************************
/* CheckRx0String()
/*******************************************/
void CheckRx0String()
{
  Rx0[Len0] = 0; // String terminieren
  int i = 0;
  
  boolean xOK = false;
  
  sCmd = sPlain = Rx0;
  
  //CleanString(); 
  
  sCmd.trim();
  sCmd.toLowerCase();
  
  Serial.println();
  Serial.print(F("Eingabe: "));
  
  if(sCmd.indexOf("pw:") == 0)
   Serial.println(sPlain); // Ausgabe mit Gross- und Kleinschreibung
  else 
   Serial.println(sCmd);
   
  
  i = sCmd.indexOf(":"); // Schreibbefehl
  
  if(i != -1 && sCmd.length() <= 24)
   xOK = SetConfig();


  if(sCmd == F("reset"))
  {
   Serial.println("Reset ausgeführt");
   delay(200);
   
 __asm volatile ("jmp 0 \n");  
  // xOK = true;
  }

  if(sCmd == F("help") || sCmd == F("hilfe") || sCmd == F("?"))
  {
   SendHelp();
   xOK = true;
  }   
 
  if(sCmd == F("info"))
  {
   SendInfo();
   xOK = true;
  }
  
  if(sCmd == F("id"))
  {
   SendID();
   xOK = true;
  }

  if(sCmd == F("alarm"))
  {
   SendAlarm();
   xOK = true;
  }  

  if(sCmd == F("sps"))
  {
   SendPLC(true);
   xOK = true;
  }
  
  
  if(sCmd == F("port") || sCmd == F("p"))
  {
   SendPort(false);
   xOK = true;
  }  
 
  if(sCmd == F("port+") || sCmd == F("p+") || sCmd == F("+"))
  {
   SendPort(true);
   xOK = true;
  }

  if(sCmd == F("merker") || sCmd == F("m"))
  {
   SendFlag();
   xOK = true;
  }
   
   if(!xOK)
   {
    Serial.println();
    Serial.print(F("Unbekannter Befehl "));
    Serial.print('"');
    Serial.print(sCmd);
    Serial.println('"');
   }
}

/*******************************************
/* CheckRx0()
/*******************************************/
void CheckRx0()
{
 unsigned int i;
  if(Rx0[0] == '{')
  {
   Serial.println(F("SPS-Programm empfangen "));
  
   if(CheckPLCArray())
   {
     Serial.print(F("SPS-Programm OK. Programmlaenge "));
     Serial.print(iPLCend + 1);
     Serial.println(" Byte");
     
     // Endadresse vom SPS-Programm speichern
     EEPROM.write(EE_PLCend, (iPLCend & B11111111)); // Low Byte
     EEPROM.write(EE_PLCend + 1, (iPLCend >> 8)); // High Byte
    
    // SPS-Programm von Rx0 zu cPLC übertragen und speichern
    for(i=0; i<= iPLCend; i++)
    {
     cPLC[i] = (byte)Rx0[i];
     EEPROM.write(EE_PLC + i, cPLC[i]); 
    } 
   }
  }
  else
  {
    // Feststellen, ob es sich um ein Befehl handelt, der vom Terminalprogramm gesendet wurde
    // (Zeichen aus ASCII Tabelle
   if(Rx0[0] > 0x20) // Wenn Zeichen größer Leerzeichen vorhanden
    CheckRx0String();
   else
   { // Test auf Initialisierungsstring  
    if(Len0 == 14)
     CheckRx0Ini();

    // Test auf Befehlssstring   
    if(Len0 == 12)
     CheckRx0Command();
   }
  }  
 // Nach Behandlung Empfangswerte zurücksetzen   
    Rx0[0] = 0;
    Len0 = 0;
}



/*******************************************
/* CheckRx0Ini()
/*******************************************/
void CheckRx0Ini()
{
  if(Rx0[0] == 0x0d && Rx0[4] == 7)
  {
   Tx07[3] = Rx0[3]; // Zähler setzen 
   Serial.write(Tx07, 21);  
  }
    
  if(Rx0[0] == 0x0d && Rx0[4] == 2)
  {
   Tx02[3] = Rx0[3]; // Zähler setzen 
   Serial.write(Tx02, 14);
  }

}

/*******************************************
/* CheckRx0Command()
/*******************************************/
void CheckRx0Command()
{
  byte b, i;
  boolean xChange = false;
  
  
     // Test auf Befehlsstring "Schalten"
     if(Rx0[0] == 0x0b && (Rx0[6] & 0xF0) == 0xD0 && (Rx0[6] & 0x0F) == bDeviceID)
     {
      bX = Rx0[7] & 0x0F;
      bP = Rx0[7];
      bP >>= 4;
      bP &= 0x0F;
       

      xOnOff = (boolean)Rx0[9];
      
        if(bQMode[bP][bX] == Schalter)// EIN/AUS
        {
          if( bX % 2 == 1 && bQMode[bP][bX-1] == Motor)
          {// Index/Adresse hier ungerade: Darf nicht von F gesendet werden. Wenn doch, dann wird zurÃ¼ckgesetzt
           xQ[bP][bX]     = false;
           xQ[bP][bX-1]   = false;
           bQMode[bP][bX] = Motor;
          }
          else
          {
           xQ[bP][bX]     = xOnOff;
           if(xOnOff)
            tQOn[bP][bX] = ByteToTime(bQOnSet[bP][bX]);
           else
            tQOn[bP][bX] = 0;
          }
        }
        else
        {
          if(bQMode[bP][bX] == Motor )// Rolllade
          {
            if(bX % 2 == 0)
            {
              bQOnSet[bP][bX+1] = bQOnSet[bP][bX];
              
              if(xOnOff)
              { 
               xQ[bP][bX] ^= true;
               xQ[bP][bX+1] = false;
               
               if(xQ[bP][bX])
               {
                tQOn[bP][bX] = ByteToTime(bQOnSet[bP][bX]); 
                tQOnDelay[bP][bX] = 5;
               }
              }
              else
              {
               xQ[bP][bX] = false;
               xQ[bP][bX+1] ^= true; 
  
               if(xQ[bP][bX+1])
               {
                tQOn[bP][bX+1] = ByteToTime(bQOnSet[bP][bX]);              
                tQOnDelay[bP][bX+1] = 5;
               }
              }
             bQMode[bP][bX+1] = Motor;
            }
            else// Index/Adresse hier ungerade: Darf nicht von F gesendet werden. Wenn doch, dann wird zurÃ¼ckgesetzt
            {
             bQMode[bP][bX-1] = Motor;
             xQ[bP][bX-1] = false;
            }            
          }
        }
     }
   
      // Test auf Befehlstring GetIO
     if(Rx0[0] == 0x0b && (Rx0[4] == 0x0E))
     {
      SendState();
     }
 

}
