void GetIO()
{
 GetInput();
 GetOutput();
 GetM();
}

/*******************************************
/* GetM() Flankenerkennung der Merker xM[]
/* 
/* 
/********************************************/
void GetM()
{
 byte i;

 for(i=0; i<=127; i++)
 {
 // Positive Flankenerkennung
 xMR[i] = xM[i];
 xMR[i] &= (xMPre[i] ^ true);
 
 // Negative Flankenerkennung
 xMF[i] = xM[i] ^ true;
 xMF[i] &= xMPre[i];
 
 // Pinänderung
 xMC[i] = xMR[i] | xMF[i];

 xMPre[i] = xM[i];   

 }
}


/*******************************************
/* GetInput() Zuweisung des Eingangsarrays xI[]
/* Aktiv: 0V, Deaktiv: VCC
/* Für die interne weiterverarbeitung wird der Eingangswert invertiert
/********************************************/
void GetInput()
{
// Hier werden in Abhängigkeit der Port-Konfiguration die entsprechenden Ports und IOs zugewiesen
// Die Ports sind beim Arduino Mega 2560 Board nicht zusammenhängend gruppiert bzw. ausgeführt
byte b1, b2, b3, b4, b5;

//*********************************************************
// 7...0
// Port0 Eingang Pin PL3, PL2, PL1, PL0, PG4, PG3, PH7, PB7
// Port1 Eingang Pin PB6, PB5, PB4, PB0, PH6, PH5, PH4, PH3

// Port4 Ausgang Pin PG5, PE2, PE3, PE4, PE5, PE6, PE7, PH2
// Port5 Ausgang Pin PL4, PL5, PL6, PL7, PD4, PD5, PD6, PD7 
//*********************************************************

for(bP=0; bP <= 3; bP++)
 { 
    
    if( bP == 0)
    { 
     b1 =  PINB ^ 0xFF; // Eingänge sind LOW-aktiv. Darum invertiert behandeln
     b1 &= B10000000;
     b1 >>= 7;
     
     b2 =  PINH ^ 0xFF;
     b2 &= B10000000;
     b2 >>= 6;
     
     b3 =  PING ^ 0xFF;
     b3 &= B00011000;
     b3 >>= 1;
          
     b4 =  PINL ^ 0xFF;
     b4 &= B00001111;
     b4 <<= 4;
     
    
     
     bI[bP] = b1 | b2 | b3 | b4;
     
     if(bReverse[bP] == 1)
      bI[bP] = ReverseByte(bI[bP]);

     if(bInverse[bP] == 1)
      bI[bP] ^= 0xFF; 
    }  
    
    
    if( bP == 1)
    { 
     b1 =  PINH ^ 0xFF;
     b1 &= B01111000;
     b1 >>= 3;

     b2 =  PINB ^ 0xFF;
     b2 &= B00000001;
     b2 <<=4;

     b3 =  PINB ^ 0xFF;
     b3 &= B01110000;
     // PB5 und PB3 sind vom PCB-Design getauscht
     b3 = ReverseByte(b3);
     b3 <<=4; 

     bI[bP] = b1 | b2 | b3;
          
     if(bReverse[bP] == 1)
      bI[bP] = ReverseByte(bI[bP]); 

     if(bInverse[bP] == 1)
      bI[bP] ^= 0xFF;     

      
    }  

// Port2 Eingang Pin PK0, PK1, PK2, PK3, PK4, PK5, PK6, PK7 
    if( (bP == 2) && (bBoardType == 64))
    {// Hier einfache Zuweisung möglich     
     bI[bP] = PINK ^ 0xFF;
     
     if(bReverse[bP] == 0)
      bI[bP] = ReverseByte(bI[bP]); 

     if(bInverse[bP] == 1)
      bI[bP] ^= 0xFF;        
    }
    
    
    if( (bP == 3) && (bBoardType == 64))
    { // Hier einfache Zuweisung möglich
     bI[bP] = PINA ^ 0xFF;
     
     if(bReverse[bP] == 0)
      bI[bP] = ReverseByte(bI[bP]); 

     if(bInverse[bP] == 1)
      bI[bP] ^= 0xFF;
    } 
  

    
 
 // Positive Flankenerkennung
 bIR[bP] = bI[bP];
 bIR[bP] &= (bIPre[bP] ^ 0xFF);
 
 // Negative Flankenerkennung
 bIF[bP] = bI[bP] ^ 0xFF;
 bIF[bP] &= bIPre[bP];
 
 // Pinänderung
 bIC[bP] = bIR[bP] | bIF[bP];

 bIPre[bP] = bI[bP]; 
  
 } 
}

/*******************************************
/* GetOutput() Zuweisung des Flankenzusände der Ausgänge
/* Aktiv: 0V, Deaktiv: VCC
/* Für die interne weiterverarbeitung wird der Eingangswert invertiert
/********************************************/
void GetOutput()
{

for(bP=4; bP <= 7; bP++)
 { 

   for(bX=0; bX <= 7; bX++)
   {    

    //Ausgänge
    // Positive Flankenerkennung ('R'ise)
    xQR[bP][bX] = xQ[bP][bX];
    xQR[bP][bX] &= (xQPre[bP][bX] ^ true);
 
    // Negative Flankenerkennung ('F'all)
    xQF[bP][bX] = xQ[bP][bX] ^ true;
    xQF[bP][bX] &= xQPre[bP][bX];
 
    // Pinänderung ('C'ange)
    xQC[bP][bX] = xQR[bP][bX] | xQF[bP][bX];

    xQPre[bP][bX] = xQ[bP][bX]; 
   }
 } 
}
