/*
Aktuelles SPS-Programm 16.05.2016
{
L6.6=64
S6.7=65
L4.0&4.1&4.2&4.3&4.4&4.5&4.6&4.7&6.0&6.1=66
W4.0|W4.1|W4.2|W4.3|W4.4|W4.5|W4.6|W4.7|W6.0|W6.1=67
L6.5=68
F6.5=69
W4.2|W6.1=70
L72=7.0
L73=7.1
L74=7.2
}

*/



/*
 * Abkürzungen
 * VKE Verknüpfungsergebnis
 *
 * Eingangs/Merker/Ausgangs-Operatoren (Abfrage):
 * 
 *   Logische Verknüpfung
 *    L  (0) lade   
 *    N  (1) lade nicht
 *    &  (2) und
 *    %  (3) und   UND nicht
 *    |  (4) oder
 *    !  (5) oder  ODER nicht
 *    X  (6) xor
 *
 *   Flankenabfrage
 *    S  (6) steigend
 *    F  (7) fallend
 *    W  (8) wechselnd
 *  
 * ********************************** 
 * 
 *  Ausgangs/Merker-Operatoren (Zuweisung):
 *   =  (11) (ist) Zuweisung Verknüpfungsergebnis
 *   #  (12) (ist nicht)Zuweisung invertiertes Verknüpfungsergebnis
 *   E  (13)ein
 *   A  (14)aus
 *   I  (15)aktueller Zustand wird invertiert
 *   
 *  
 * Operanden
 * ob es sich um ein oder ausgänge handelt wird nicht vorangestellt
 * E/A  [0.0...7.7]
 * M  [0...80]
 * 
 * 
 * s 0.1      e 3.1  40s 
   s 0.2      a 3.1    
              
   s 0.0      i 3.0    
              
     1.0  u 1.1  = A2.0     Direkte Zuweisung auf Ausgang nicht möglich
                                weil HA auch auf Ausgänge zugreift
                                In diesem Fall wird der Ausgang mit der wechselnden
                                Flanke des Verknüpfungsergebnis ein oder ausgesschaltet
                           
    1.2      = 2.1    Hat den
  w 1.2      i  2.1    gleichen Effekt
            
  w 1.3      e 2.3
 * 
 * 
 */

/*******************************************
/* CharFormat()
/*******************************************/ 
char CharFormat(byte b)
{
 char c;
 String s;


    c = (char)b;
    s = (String)c;
    s.toUpperCase();
    c = s.charAt(0);

  //  Serial.print("Format: ");
  //  Serial.println(c);    
    
  return c;
}

/*******************************************
/* IsPLCStringOK()
/*******************************************/ 
boolean IsPLCArrayOK()
{
 char c; 
 boolean x = true;
 unsigned int i, ii;

 ii= 0;

    for(i=0; i<Len0; i++)
   {

    c = CharFormat(Rx0[i]);
    Rx0[i] = c;    

    if(c == '{' ||
       c == '}' ||
       c == 'L' ||
       c == 'N' ||
       c == '&' ||
       c == '%' ||
       c == '|' ||
       c == '!' ||
       c == 'X' ||
       c == 'S' ||
       c == 'F' ||
       c == 'W' ||
       c == '=' ||
       c == '#' ||
       c == 'E' ||
       c == 'A' ||
       c == 'I' ||
       c == '.' ||
       c == '0' ||
       c == '1' ||
       c == '2' ||
       c == '3' ||
       c == '4' ||
       c == '5' ||
       c == '6' ||
       c == '7' ||
       c == '8' ||
       c == '9' ||
       isWhitespace(c) || 
       isControl(c))
    {
      
      if(!isWhitespace(c) &&  !isControl(c)) 
      {
       Rx0[ii] =  Rx0[i]; 
       ii++;
      }


    
    }
    else
    {
     x = false;

     Serial.print(F("Unerlaubtes Zeichen "));
     Serial.print(Rx0[i]);
     Serial.println(F(" verwendet!"));
     return x;   
    } 
   }

 Len0 = ii;

     for(i=0; i<Len0; i++)
      Serial.print(Rx0[i]);
      
 Serial.println();        
 Serial.println(F("Kein unerlaubtes Zeichen "));
 Serial.println();
 return x;
  
}

/*******************************************
/* CheckPLCArray()
/*******************************************/

// Hier wird das Rx0-Array in Bytecode konvertiert, damit weniger Speicherplatz benutzt wird.
// So ist für jede Anweisung bzw. Anweisungskombination wie "us" (und fallende Flanke) und für jeden 
// Operanden E/A/M nur ein Byte erforderlich. Bei syntaktsch korrekten Programm wird nach dem verlassen dieser
// Funktion der formatierte Rx0-Array in das PLC-Array geschrieben
boolean CheckPLCArray()
{
  boolean xRes = false;
    
  char c, cNext;
  unsigned int i, iAdr;
  byte bM; // Merkeradresse

  if(!IsPLCArrayOK())
  {
   return false;
  }


  if(Rx0[Len0-1] == '}')  // Ende mit "}" ?
  {
   Serial.println("SPS");

   iAdr = 0;
   
   for(i=1; i<Len0; i++)
   {
    c = CharFormat(Rx0[i]);

    if(c == '}')
    {
      Serial.println(F("Programmende"));
      return true;
    }
   

   //Serial.println(c);
    Rx0[iAdr] = 0;
    //Operator feststellen
    

    if( c == 'L' ||  c == 'N' ||  c == '&' ||  c == '%' ||  c == '|' ||  c == '!' ||  c == 'X')  
    {
      switch (c)
      {
       case 'L':
       Rx0[iAdr] |= _l;
       break;
   
       case 'N':
       Rx0[iAdr] |= _ln;
       break;
    
       case '&':
       Rx0[iAdr] |= _u;
       break;
       
       case '%':
       Rx0[iAdr] |= _un;
       break;
       
       case '|':
       Rx0[iAdr] |= _o;
       break;
       
       case '!':
       Rx0[iAdr] |= _on;
       break;
       
       case 'X':
       Rx0[iAdr] |= _x;
       break;     
      }

     // Feststellen ob eine Flankenabfrage im nächsten Zeichen folgt
     cNext = CharFormat(Rx0[i+1]);

      switch (cNext)
      {
       case 'S':
        Rx0[iAdr] |= _s;
        i++;
       break; 
       
       case 'F':
        Rx0[iAdr] |= _f;
        i++;
       break;

       case 'W':
        Rx0[iAdr] |= _w;
        i++;
       break;         
      }   
     }

    if( c == 'S' ||  c == 'F' ||  c == 'W')  
    {
      switch (c)
      {
       case 'S':
        Rx0[iAdr] |= _s;
       break; 
       
       case 'F':
        Rx0[iAdr] |= _f;
       break;

       case 'W':
        Rx0[iAdr] |= _w;
       break;         
      }
    }


    if( c == '=' || c == '#' || c == 'E' ||  c == 'A' ||  c == 'I')  
    {
      switch (c)
      {
       case '=':
        Rx0[iAdr] |= _ist;
       break; 
       
       case '#':
        Rx0[iAdr] |= _istn;
       break;

       case 'E':
        Rx0[iAdr] |= _e;
       break; 

       case 'A':
        Rx0[iAdr] |= _a;
       break; 

       case 'I':
        Rx0[iAdr] |= _i;
       break; 
                             
      } 
    }   
    
       Serial.print(F("RX Adresse:"));
       Serial.print(i);  
       Serial.print(F(" PLC Adresse b:"));
       Serial.print(iAdr);  
       Serial.print(F("   PLC Befehl: "));
       Serial.println(Rx0[i], BIN);  

    // nächster Operand(Adresse) muss nummerisch sein


   c = CharFormat(Rx0[++i]);
   
   if(isDigit(c))  // Ist digit nummerisch?
   {

    // E/A oder Merkeradresse

    if(CharFormat(Rx0[++i]) == '.')
    {// E/A-Adresse
    //  Serial.print(F("EA-Operand num? "));

      if(isDigit(Rx0[++i]))
      {
     //  Serial.println("Ja");
     //  Serial.print(F("EA-Operand 0...7? "));

       if(IsNumeric(c, '7') && IsNumeric(Rx0[i], '7'))
       {
        // Nächste SPS adresse
        iAdr++;
        Rx0[iAdr] = 0;
        Rx0[iAdr] = c - 48;
        Rx0[iAdr] <<=3;
        Rx0[iAdr] |= Rx0[i]- 48;
     
        Serial.print(F("RX Adresse:"));
        Serial.print(i);        
        Serial.print(F(" PLC Adresse c:"));
        Serial.print(iAdr);  
        Serial.print(F("   PLC Ziel: "));
        Serial.print(Rx0[i], BIN); 
        Serial.print(F(" = Port "));
        Serial.print(c - 48);  
        Serial.print(F(" Bit "));
        Serial.println( Rx0[i] - 48);
        Serial.println();        
       }
       else
       {
        Serial.println(F("EA-Operand Bereichsueberschreitung "));
        return false;
       }
      }
      else
      {
       Serial.println(F("E/A-Operand nicht nummerisch"));
       return false;
      }
 
    
    }
    else
    { // Merkeradresse?
      // OK, hinter dieser Zahl 
       iAdr++;

      if(isDigit(Rx0[i])) // i ist bereits durch die Prüfung auf '.' gesetzt
      {// Die merkeradresse besteht aus 2 Digits

        bM =  (c-48) * 10;
        bM += (Rx0[i]- 48);

      }
      else
      {//Die merkeradresse besteht aus einem Digit
       bM = (c-48);
       i--;
      }

       // Flag für Merkerkennzeichnung setzen 
       bM  |= B10000000;
       Rx0[iAdr] = bM;
       
        Serial.print(F("RX Adresse:"));
        Serial.print(i);  
        Serial.print(F(" PLC Adresse M:"));
        Serial.print(iAdr);  
        Serial.print(F("   PLC Ziel: "));
        Serial.print(Rx0[i], BIN); 
        Serial.print(F(" = Merker "));
        Serial.println(bM & B01111111);  
        Serial.println();          
     } 
   }
   else
   {
    Serial.println(F("Operanden-Adresse ist nicht nummerisch"));
    i = Len0; // for-Schleife verlassen
   }
   
    iPLCend = iAdr;
    iAdr++;
   } 
  }
  else
   Serial.println(F("Geschlossene geschweifte Klammer fehlt"));
}


/*******************************************
/* PLC()
/*******************************************/ 
// Operanden Adressierung
// Bit 0...2  E/A  [0...7] 
// Bit 3...5 PORT
// Bit 7 [1] = Merker Bit [0...6] = Merkeradresse
void PLC()
{

  br1 = br2 =0;

  boolean xS;  //
  int i;
  
 
  for(i=0; i<=iPLCend; i+=2)
  {
   xS = GetVKE(i); 
  }
}

/*******************************************
/* GetVKE()
/*******************************************/ 
boolean GetVKE( int i)
{
  byte bS = false; // Status E/A/M >boolean< funktioniert nicht wegen bS = bIR[bP] >> bX;
  boolean isFlag = false;
  byte bFlagNbr = 0;
 
  // Wenn bit 7 gessetzt ist, dann handelt es sich um eine Merkeradresse
  if((cPLC[i+1] & B10000000) > 0)
  {
   isFlag = true; 
   bFlagNbr = cPLC[i+1] & B01111111;
   //Serial.println(bFlagNbr);
  }
  else
  { 
   bX   = cPLC[i+1];
   bP = (bX >> 3);
  
   bX   &= B00000111;
   bP   &= B00000111;
  }
  

// Wenn operator zuvor eine Zuweisung war und der jetzige nicht, dann wird das VKE  nicht gelöscht
// Damit wird erreicht, dass aufeinander folgende Zuweisungen das vorherige VKE nutzen können.
if(xAllocation && cPLC[i] != _ist && cPLC[i] != _istn && cPLC[i] != _e && cPLC[i] != _a && cPLC[i] != _i)
{
 br1 = false;
 xAllocation = false;
}

//  IO-Status ermitteln; high, low, oder Flanke
     switch (cPLC[i] & B00001111) //Low-Nibble
    {
      
     case _l: // keine Flankenabfrage    
      if(isFlag)
      {
       bS = xM[bFlagNbr];
      }
      else
      {
       if(Port[bP].Fnc == Ausg)
        bS =    xQ[bP][bX]; 
       else
        bS = bI[bP] >> bX; bS &= B00000001; 
       }
      break;
 
     case _s : 
      if(isFlag)
      {
       bS = xMR[bFlagNbr];
      }
      else
      {     
       if(Port[bP].Fnc == Ausg)
       {
        bS = xQR[bP][bX]; 
       }
       else
       {
        bS = bIR[bP] >> bX; bS &= B00000001; 
       } 
      }
     break;
     
     
     case _f:  
      if(isFlag)
      {
       bS = xMF[bFlagNbr];
      }
      else
      {     
       if(Port[bP].Fnc == Ausg)
       {
        bS = xQF[bP][bX]; 
       }
       else
       {
        bS = bIF[bP] >> bX; bS &= B00000001; 
       } 
      }
     break;   
   
   
     case _w:  
      if(isFlag)
      {
       bS = xMC[bFlagNbr];
      }
      else
      {     
       if(Port[bP].Fnc == Ausg)
       {
        bS = xQC[bP][bX]; 
       }
       else
       {
        bS = bIC[bP] >> bX; bS &= B00000001; 
       }
      } 
     break;       

    } 
   
// ******************************************************  
// VKE ermitteln
// ******************************************************  
    switch (cPLC[i] & B11110000) //High-Nibble
    {
     case _l: // Lade
     br1 = bS; 
     break;  
  
     
     case _ln: // Lade nicht
     br1 = !bS; 
     break;       
   
      
     case _u: // und
     br1 &= bS; 
     break;
  
     
     case _un: // und nicht
     br1 &= !bS; 
     break;     
  
    
     case _o: // oder
     br1 |= bS; 
     break;
  
  
     case _on: // oder nicht
     br1 |= !bS; 
     break;  
 
 
     case _x: // xor
     br1 ^= bS; 
     break;      
      
// ****************************************************** 
// Zuweisungen
// Achtung: bei Zuweisungen, die in jedem PLC-Zyklus stattfinden,
// kann die Zeit nicht ablaufen, weil sie immer wieder gesetzt wird.
// Darum sollte das VKE möglichst mit Flanken erzeugt werden. 
// ******************************************************
   
      case _ist: // ist gleich
      
       if(isFlag)
        {
        if(br1)
         tMOnRun[bFlagNbr] = ByteToTime(bMOnSet[bFlagNbr]);
        else
         tMOnRun[bFlagNbr] = 0;  
        
        xM[bFlagNbr] = br1;
       }
       else
       {         
        if(br1)
         tQOn[bP][bX] = ByteToTime(bQOnSet[bP][bX]);
        else
         tQOn[bP][bX] = 0;            
                    
        xQ[bP][bX] = br1; 
       }
        
       
      xAllocation = true;
     break;  
     
      case _istn: // ist nicht gleich
      
       if(isFlag)
        {
        if(!br1)
         tMOnRun[bFlagNbr] = ByteToTime(bMOnSet[bFlagNbr]);
        else
         tMOnRun[bFlagNbr] = 0;  
        
        xM[bFlagNbr] = !br1;
       }
       else
       {         
        if(!br1)
         tQOn[bP][bX] = ByteToTime(bQOnSet[bP][bX]);
        else
         tQOn[bP][bX] = 0;            
                    
        xQ[bP][bX] = !br1; 
       }
        
       
      xAllocation = true;
     break;       
 
     
     case _e: // EIN
      if(br1)
      {
       if(isFlag)
       {
        tMOnRun[bFlagNbr] = ByteToTime(bMOnSet[bFlagNbr]); 
        xM[bFlagNbr] = true;
       }
       else
       {  
        tQOn[bP][bX] = ByteToTime(bQOnSet[bP][bX]);
        xQ[bP][bX] = true; 
       }
      }
       
      xAllocation = true;
     break;  
 
     
     case _a: // AUS
      if(br1)
      {
       if(isFlag)
       {
        tMOnRun[bFlagNbr] = 0;
        xM[bFlagNbr] = false;
       }
       else
       {         
        tQOn[bP][bX] = 0;
        xQ[bP][bX] = false; 
       }
      }
       
      xAllocation = true;      
     break; 


     case _i: // invertieren
      if(br1)
      { 
       if(isFlag)
       {
        xM[bFlagNbr] ^= true;

        if(xM[bFlagNbr])
         tMOnRun[bFlagNbr] = ByteToTime(bMOnSet[bFlagNbr]);
        else
         tMOnRun[bFlagNbr] = 0;         
        
        }
       else
       {  
        xQ[bP][bX] ^= true;
      
        if(xQ[bP][bX])
         tQOn[bP][bX] = ByteToTime(bQOnSet[bP][bX]);
        else
         tQOn[bP][bX] = 0;  
        
       }       
      }
       
      xAllocation = true;      
     break;       
   }

  
} 
